routes/web.php
<?php

use App\Http\Controllers\Pages\ThankYouController;
use App\Models\Order;
use Illuminate\Support\Facades\Route;

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::resource('products', \App\Http\Controllers\ProductsController::class)->only(['show', 'index']);
Route::get('checkout', \App\Http\Controllers\CheckoutController::class)->name('checkout');
Route::get('orders/{vendorOrderId}/thank-you', ThankYouController::class)->name('thankyou');

Route::middleware(['auth'])->group(function() {
    Route::post('wishlist/{product}', [\App\Http\Controllers\WishListController::class, 'add'])->name('wishlist.add');
    Route::delete('wishlist/{product}', [\App\Http\Controllers\WishListController::class, 'remove'])->name('wishlist.remove');

    Route::name('account.')->prefix('account')->group(function() {
        Route::get('/', [App\Http\Controllers\Account\HomeController::class, 'index'])->name('home');
        Route::get('wishlist', App\Http\Controllers\Account\WishListController::class)->name('wishlist');
    });

    Route::get('invoices/{order}', \App\Http\Controllers\InvoicesController::class)->name('invoice');
});

Route::name('cart.')->prefix('cart')->group(function() {
    Route::get('/', [\App\Http\Controllers\CartController::class, 'index'])->name('index');
    Route::post('{product}', [\App\Http\Controllers\CartController::class, 'add'])->name('add');
    Route::delete('/', [\App\Http\Controllers\CartController::class, 'remove'])->name('remove');
    Route::put('{product}/count', [\App\Http\Controllers\CartController::class, 'count'])->name('count');
});

// site.com/admin
Route::name('admin.')->prefix('admin')->middleware('role:admin|moderator')->group(function() {
    Route::get('/', \App\Http\Controllers\Admin\DashboardController::class)->name('dashboard');
    Route::resource('products', \App\Http\Controllers\Admin\ProductsController::class)->except(['show']);
    Route::resource('categories', \App\Http\Controllers\Admin\CategoriesController::class)->except(['show']);
});

Route::name('ajax.')->prefix('ajax')->group(function() {
    Route::group(['auth', 'role:admin|moderator'], function() {
        Route::post('products/{product}/images', \App\Http\Controllers\Ajax\Products\UploadImages::class)->name('product.images.upload');
        Route::delete('images/{image}', \App\Http\Controllers\Ajax\RemoveImageController::class)->name('image.remove');
    });

    Route::prefix('paypal')->name('paypal.')->group(function() {
        Route::post('order', [\App\Http\Controllers\Ajax\Payments\PaypalController::class, 'create'])->name('order.create');
        Route::post('order/{vendorOrderId}/capture', [\App\Http\Controllers\Ajax\Payments\PaypalController::class, 'capture'])->name('order.capture');
    });
});

Route::name('callbacks.')->prefix('callbacks')->group(function() {
    Route::get('telegram', \App\Http\Controllers\Callbacks\JoinTelegramController::class)
        ->middleware(['role:admin'])
        ->name('telegram');
});

app/Http/Controllers/CartController.php
<?php

namespace App\Http\Controllers;

use App\Models\Product;
use Gloudemans\Shoppingcart\Facades\Cart;
use Illuminate\Http\Request;

class CartController extends Controller
{
    public function index()
    {
        $cart = Cart::instance('cart');

        ds($cart->content());

        return view('cart/index', compact('cart'));
    }

    public function add(Product $product)
    {
        Cart::instance('cart')
            ->add($product->id, $product->title, 1, $product->finalPrice)
            ->associate(Product::class);

        notify()->success("Product '$product->title' was added to the cart");

        return redirect()->back();
    }

    public function remove(Request $request)
    {
        $data = $request->validate([
            'rowId' => ['required', 'string']
        ]);

        Cart::instance('cart')->remove($data['rowId']);

        notify()->success("Product was removed from the cart");

        return redirect()->back();
    }

    public function count(Request $request, Product $product)
    {
        $data = $request->validate([
            'rowId' => ['required', 'string'],
            'qty' => ['required', 'numeric', 'min:1', 'max:' . $product->quantity],
        ]);

        Cart::instance('cart')->update($data['rowId'], $data['qty']);

        notify()->success("Product count was updated");

        return redirect()->back();
    }
}

resources/views/cart/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-12 py-5 text-center">
                <h1>Cart</h1>
            </div>
        </div>
        <div class="row">
            <div class="col-12 col-sm-9">
                <table class="table table-striped table-hover">
                    <thead>
                    <tr>
                        <th>Image</th>
                        <th>Product</th>
                        <th>Qty</th>
                        <th>Price</th>
                        <th>Subtotal</th>
                        <th>Actions</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($cart->content() as $item)
                        <tr>
                            <td><img src="{{ $item->model->thumbnailUrl }}" style="width: 75px;"
                                     alt="{{ $item->name }}"></td>
                            <td>
                                <a href="{{ route('products.show', $item->model) }}">{{ $item->name }}</a>
                            </td>
                            <td>
                                <form action="{{ route('cart.count', $item->model) }}" method="POST">
                                    @method('PUT')
                                    @csrf
                                    <input type="hidden" name="rowId" value="{{ $item->rowId }}"/>
                                    <input type="number" class="form-control product-qty" min="1"
                                           max="{{ $item->model->quantity }}" name="qty" value="{{ $item->qty }}"/>
                                </form>
                            </td>
                            <td>{{ $item->price }} $</td>
                            <td>{{ $item->subtotal }} $</td>
                            <td>
                                <form action="{{ route('cart.remove') }}" method="POST">
                                    @method('DELETE')
                                    @csrf
                                    <input type="hidden" name="rowId" value="{{ $item->rowId }}"/>
                                    <button type="submit" class="btn btn-danger"><i class="fa-solid fa-trash"></i>
                                    </button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
            <div class="col-12 col-sm-3">
                <h1 class="mb-3">Summary</h1>
                <table class="table table-striped table-hover">
                    <tbody>
                    <tr>
                        <td>Subtotal</td>
                        <td>{{ $cart->subtotal() }} $</td>
                    </tr>
                    <tr>
                        <td>Tax</td>
                        <td>{{ $cart->tax() }} $</td>
                    </tr>
                    <tr>
                        <td>Total</td>
                        <td>{{ $cart->total() }} $</td>
                    </tr>
                    </tbody>
                </table>
                <br>
                <a href="{{ route('checkout') }}" class="btn w-100 btn-outline-success">Proceed to checkout</a>
            </div>
        </div>
    </div>
@endsection

@push('footer-js')
    @vite(['resources/js/cart.js'])
@endpush